\ Copyright (c) 2002 by Wuja
\ All rights reserved 
\
\ HFDEMO.F   18MAY02 created by Wuja.
\
\ HenceForth DEMO Definition.
\
\ Description:
\     This is my first time to port Dr. Ting's eForth system to the Win32 environment.
\   It is also my first time to have so much interest in the MS Windows programming.
\   Before this, of couse, I have some knowledge about how to program a Widowns program.
\   But I didn't have any idea to connect the two world between the Forth and the Windows.
\   Thank Yap's WeForth for giving me so perfect experience about eForth's first step in 
\   the Windows. Based on it, then I can get enough encouragement to try my first step. 
\
\ Version Hsiroty: 
\ V0.1,    18MAY02WUJA,  o Build a MessageBox calling in high-level definition.
\ V0.2,    21MAY02WUJA,  o Build some console calling in high-level definition.
\ V0.32,   30MAY02WUJA,  o Fix the HF crash problem after going back from WINDOWDEMO. It is 
\                          caused by the wrong length of message data structure.    
\			 o Fix the window propcedure crash problem in the Win98. It is caused
\                          by re-entering of window procedure.    
\ V0.33,   02JUN02WUJA,  o Rewrite all demo in new DLL and API data structure. 
\                        o Move console IO definitions to HFEXT.f 
\			 o Redefine CALL BACK mechanism
\                        o Move CALL BACK mechanism definitions to HFAWIN32.f
\ V0.40,   04JUN02WUJA,  o Load ICON from HF.exe itself. 
\                               

CREATE USER32 				\ Make a USER32 DLL structure manually
HERE 0 , 0 , 0 , DLL-LINK DUP @ , !
HERE 					\ Build string address manually
CHAR U C, CHAR S C, CHAR E C, CHAR R C,
CHAR 3 C, CHAR 2 C, CHAR . C, CHAR d C,
CHAR l C, CHAR l C, 0 C,
USER32 CELL+ !                         

CREATE MessageBoxA			\ Make a MessageBoxA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' MessageBoxA ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR M C, CHAR e C, CHAR s C, CHAR s C,
CHAR a C, CHAR g C, CHAR e C, CHAR B C,
CHAR o C, CHAR x C, CHAR A C, 0 C,
MessageBoxA CELL+ !                         

\ Message Box DEMO
CREATE WELCOME
CHAR W C, CHAR e C, CHAR l C, CHAR c C, 		\ "Welcome to HenceForth"
CHAR o C, CHAR m C, CHAR e C, BL     C,
CHAR t C, CHAR o C, BL     C, CHAR H C,
CHAR e C, CHAR n C, CHAR c C, CHAR e C,
CHAR F C, CHAR o C, CHAR r C, CHAR t C,
CHAR h C, 0 C, 

: HELLO ( -- )
  41 >R WELCOME >R WELCOME >R 0 >R MessageBoxA Return@
  CR ." The button you press is : " 
  1 = IF ." OK" ELSE ." CANCEL" THEN CR ;

\ Open File Dialog Box DEMO

: OPENFILEDEMO ( -- )
  OFN >R GetOpenFileNameA Return@
  CR 1 = 
  IF ." You select a file"
  ELSE ." You don't select any file" 
  THEN CR ;


\ A simple Window Demo

CREATE WNDCLASS  A CELLS ALLOT

\ typedef struct _WNDCLASS { 
\    UINT    style; 
\    WNDPROC lpfnWndProc; 
\    int     cbClsExtra; 
\    int     cbWndExtra; 
\    HANDLE  hInstance; 
\    HICON   hIcon; 
\    HCURSOR hCursor; 
\    HBRUSH  hbrBackground; 
\    LPCTSTR lpszMenuName; 
\    LPCTSTR lpszClassName; 
\ } WNDCLASS; 

CREATE MESSAGE  7 CELLS ALLOT

\ typedef struct tagMSG {     // msg 
\    HWND   hwnd;     
\    UINT   message; 
\    WPARAM wParam; 
\    LPARAM lParam; 
\    DWORD  time; 
\    POINT  pt; 
\ } MSG; 


CREATE CLASS_NAME
CHAR C C, CHAR l C, CHAR a C, CHAR s C,
CHAR s C, CHAR W C, CHAR 1 C, 0 C,

CREATE WINDOW_NAME
CHAR H C, CHAR e C, CHAR n C, CHAR c C,
CHAR e C, CHAR F C, CHAR o C, CHAR r C,
CHAR t C, CHAR h C, 20 C,     CHAR W C,
CHAR i C, CHAR n C, CHAR d C, CHAR o C,
CHAR w C, CHAR s C, 20 C,     CHAR D C, 
CHAR e C, CHAR m C, CHAR o C, 0 C,

CREATE GDI32 				\ Make a GDI32 DLL structure manually
HERE 0 , 0 , 0 , DLL-LINK DUP @ , !
HERE 					\ Build string address manually
CHAR G C, CHAR D C, CHAR I C, CHAR 3 C,
CHAR 2 C, CHAR . C, CHAR d C, CHAR l C,
CHAR l C, 0 C,
GDI32 CELL+ !                         

CREATE GetModuleHandleA			\ Make a GetModuleHandleA API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' GetModuleHandleA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR G C, CHAR e C, CHAR t C, CHAR M C,
CHAR o C, CHAR d C, CHAR u C, CHAR l C,
CHAR e C, CHAR H C, CHAR a C, CHAR n C,
CHAR d C, CHAR l C, CHAR e C, CHAR A C,
0 C,
GetModuleHandleA CELL+ !                         

CREATE GetCommandLineA			\ Make a GetCommandLineA API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' GetCommandLineA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR G C, CHAR e C, CHAR t C, CHAR C C,
CHAR o C, CHAR m C, CHAR m C, CHAR a C,
CHAR n C, CHAR d C, CHAR L C, CHAR i C,
CHAR n C, CHAR e C, CHAR A C, 0 C,
GetCommandLineA CELL+ !                         

CREATE DefWindowProcA			\ Make a DefWindowProcA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' DefWindowProcA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR D C, CHAR e C, CHAR f C, CHAR W C,
CHAR i C, CHAR n C, CHAR d C, CHAR o C,
CHAR w C, CHAR P C, CHAR r C, CHAR o C,
CHAR c C, CHAR A C, 0 C,
DefWindowProcA CELL+ !                         

CREATE LoadImageA			\ Make a LoadImageA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' LoadImageA ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR L C, CHAR o C, CHAR a C, CHAR d C,
CHAR I C, CHAR m C, CHAR a C, CHAR g C,
CHAR e C, CHAR A C, 0 C,
LoadImageA CELL+ !                         

CREATE GetStockObject			\ Make a GetStockObject API structure manually
HERE 0 , 0 , 0 , GDI32 , API-LINK DUP @ , !
HERE ' GetStockObject ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR G C, CHAR e C, CHAR t C, CHAR S C,
CHAR t C, CHAR o C, CHAR c C, CHAR k C,
CHAR O C, CHAR b C, CHAR j C, CHAR e C,
CHAR c C, CHAR t C, 0 C,
GetStockObject CELL+ !                         

CREATE RegisterClassA			\ Make a RegisterClassA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' RegisterClassA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR R C, CHAR e C, CHAR g C, CHAR i C,
CHAR s C, CHAR t C, CHAR e C, CHAR r C,
CHAR C C, CHAR l C, CHAR a C, CHAR s C,
CHAR s C, CHAR A C, 0 C,
RegisterClassA CELL+ !                         

CREATE CreateWindowExA			\ Make a CreateWindowExA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' CreateWindowExA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR C C, CHAR r C, CHAR e C, CHAR a C,
CHAR t C, CHAR e C, CHAR W C, CHAR i C,
CHAR n C, CHAR d C, CHAR o C, CHAR w C,
CHAR E C, CHAR x C, CHAR A C, 0 C,
CreateWindowExA CELL+ !                         

CREATE ShowWindow			\ Make a ShowWindow API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' ShowWindow ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR S C, CHAR h C, CHAR o C, CHAR w C,
CHAR W C, CHAR i C, CHAR n C, CHAR d C,
CHAR o C, CHAR w C, 0 C,
ShowWindow CELL+ !                         

CREATE UpdateWindow			\ Make a UpdateWindow API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' UpdateWindow ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR U C, CHAR p C, CHAR d C, CHAR a C,
CHAR t C, CHAR e C, CHAR W C, CHAR i C,
CHAR n C, CHAR d C, CHAR o C, CHAR w C,
0 C,
UpdateWindow CELL+ !                         

CREATE PostQuitMessage			\ Make a PostQuitMessage API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' PostQuitMessage ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR P C, CHAR o C, CHAR s C, CHAR t C,
CHAR Q C, CHAR u C, CHAR i C, CHAR t C,
CHAR M C, CHAR e C, CHAR s C, CHAR s C,
CHAR a C, CHAR g C, CHAR e C, 0 C,
PostQuitMessage CELL+ !                         

CREATE GetMessageA			\ Make a GetMessageA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' GetMessageA ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR G C, CHAR e C, CHAR t C, CHAR M C,
CHAR e C, CHAR s C, CHAR s C, CHAR a C, 
CHAR g C, CHAR e C, CHAR A C, 0 C,
GetMessageA CELL+ !                         

CREATE TranslateMessage			\ Make a TranslateMessageA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' TRanslateMessage ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR T C, CHAR r C, CHAR a C, CHAR n C,
CHAR s C, CHAR l C, CHAR a C, CHAR t C, 
CHAR e C, CHAR M C, CHAR e C, CHAR s C,
CHAR s C, CHAR a C, CHAR g C, CHAR e C, 
0 C,
TranslateMessage CELL+ !                         

CREATE DispatchMessageA			\ Make a DispatchMessageA API structure manually
HERE 0 , 0 , 0 , USER32 , API-LINK DUP @ , !
HERE ' DispatchMessageA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR D C, CHAR i C, CHAR s C, CHAR p C,
CHAR a C, CHAR t C, CHAR c C, CHAR h C, 
CHAR M C, CHAR e C, CHAR s C, CHAR s C,
CHAR a C, CHAR g C, CHAR e C, CHAR A C,
0 C,
DispatchMessageA CELL+ !                         

VARIABLE hInstance				\ Holder of HF.exe's handle
VARIABLE pCommandLine                           \ Pointer to the command line string
VARIABLE hDefWindowProcA                        \ Handle of default window procedure
VARIABLE hwnd                                   \ window handle
VARIABLE hIcon					\ Icon handle
VARIABLE hCursor   				\ Cursor handle
VARIABLE hbrBackground				\ Background handle

: GET_HANDLE1 ( -- )
  0 >R GetModuleHandleA Return@ hInstance ! 	\ get HF.exe's handle
  ;

: GET_HANDLE2 ( -- )
  GetCommandLineA Return@ pCommandLine !        \ get pointer of command line
  ;

: GET_HANDLE3 ( -- )
  [ DefWindowProcA ] LITERAL @
  hDefWindowProcA !                		\ save DefWindowProcA handle
  ;

: GET_HANDLE4 ( -- )
  0040 >R					\ fuLoad = LR_DEFAULTSIZE	
  0 >R 						\ cyDesired = 0
  0 >R	 					\ cxDesired = 0
  1 >R 						\ uType = IMAGE_ICON
\  7F00 >R                  			\ lpszName = OIC_SAMPLE
  1 >R                  			\ lpszName = 1
\  0 >R                                         \ hinst = OEM image
  hInstance @ >R                                \ hinst = hInstance
  LoadImageA Return@ hIcon !  
  ;

: GET_HANDLE5 ( -- )
  0040 >R					\ fuLoad = LR_DEFAULTSIZE	
  0 >R						\ cyDesired = 0
  0 >R						\ cxDesired = 0
  2 >R 						\ uType = IMAGE_CURSOR
  7F00 >R                 			\ lpszName = OCR_NORMAL
  0 >R                                          \ hinst = OEM image
  LoadImageA Return@ hCursor !  
  ;

: GET_HANDLE6 ( -- )
  1 >R GetStockObject Return@ hbrBackground !   \ hbrBackground = WHITE_BRUSH
  ;
  
: GET_HANDLE ( -- )
  GET_HANDLE1
  GET_HANDLE2
  GET_HANDLE3
  GET_HANDLE4
  GET_HANDLE5
  GET_HANDLE6
  ;  

VARIABLE hPostQuitMessage 

: GETPOSTQUITMESSAGE ( -- )
  [ PostQuitMessage ] LITERAL @
  hPostQuitMessage ! ;

: WINDOW_PROC ( -- )
  CB:  						\ Begin of CALL BACK mechanism
  message@ 02 = IF				\ check if WM_DESTROY
    0 >R hPostQuitMessage @ EXECUTE  	        \ PostQuitMessage
    0						\ return NULL
  ELSE
    hwnd@ message@ wParam@ lParam@ >R >R >R >R
    hDefWindowProcA @ EXECUTE  Return@
  THEN
  CB;						\ End of CALL BACK mechanism
  ;    

: INITIAL_CLASS ( -- )
  0 WNDCLASS !					\ style = NULL
  [ ' WINDOW_PROC ] LITERAL 			 
  WNDCLASS 1 CELLS + !  			\ lpfnWndProc = WINDOW_PROC
  0 WNDCLASS 2 CELLS + !			\ cbClsExtra = 0
  0 WNDCLASS 3 CELLS + !			\ cbWndExtra = 0
  hInstance @  WNDCLASS 4 CELLS + !             \ hInstance = hInstance
  hIcon @ WNDCLASS 5 CELLS + !			\ hIcon = hIcon
  hCursor @ WNDCLASS 6 CELLS + ! 		\ hCursor = hCursor
  hbrBackground @ WNDCLASS 7 CELLS + !          \ hbrBackground = hbrBackground
  0 WNDCLASS 8 CELLS + !                        \ lpszMenuName = NULL
  CLASS_NAME WNDCLASS 9 CELLS + !               \ lpszClassName = CLASS_NAME
  ;

: REGISTER_CLASS ( -- )
  WNDCLASS >R  RegisterClassA                   \ Register class,WNDCLASS
  ; 

: CREATE_WINDOW ( -- )
  0 >R						\ lpParam = NULL
  hInstance @ >R				\ hInstance = hInstance
  0 >R 						\ hMenu = NULL
  0 >R						\ hWndParent = NULL
  0 >R						\ nHeight = 0
  80000000 >R 					\ nWidth = CW_USEDEFAULT
  0 >R                                          \ y = 0
  80000000 >R 					\ x = CW_USEDEFAULT 
  0                                             \ WS_OVERLAPPEDWINDOW = 
  0 OR						\  WS_OVERLAPPED  |    
  00C00000 OR                  			\  WS_CAPTION     |    
  00080000 OR                  			\  WS_SYSMENU     |    
  00040000 OR                  			\  WS_THICKFRAME  |    
  00020000 OR                  			\  WS_MINIMIZEBOX |    
  00010000 OR >R              			\  WS_MAXIMIZEBOX
  WINDOW_NAME >R				\ lpWindowName = WINDOW_NAME
  CLASS_NAME >R					\ lpClassName = CLASS_NAME
  0 >R						\ dwExStyle = NULL
  CreateWindowExA Return@ hwnd !		\ create window and save window handle
  ;

: SHOW_WINDOW ( -- )
  A >R hwnd @ >R ShowWindow                     \ nCmdShow = SW_SHOWDEFAULT 
  ;    

: UPDATE_WINDOW ( -- )
  hwnd @ >R UpdateWindow  
  ;


: WINDOWDEMO ( -- )
  GETPOSTQUITMESSAGE
  GET_HANDLE
  INITIAL_CLASS
  REGISTER_CLASS
  CREATE_WINDOW
  SHOW_WINDOW
  UPDATE_WINDOW
 
  BEGIN 
    0 >R 0 >R 0 >R MESSAGE >R GetMessageA Return@
    WHILE
    MESSAGE >R TranslateMessage                
    MESSAGE >R DispatchMessageA                
  REPEAT
  ;

