VARIABLE hTextWin
VARIABLE LASTTEXTWIN

CREATE CRLF $D C, $A C, 0 C,

$401 CONSTANT WM_REDRAW    \ custom message

0  hTextWin GetProperty: TEXTWINCHILDPROC  
0  hTextWin SetProperty: setTEXTWINCHILDPROC
4 hTextWin GetProperty: TEXTWINTYPE
4 hTextWin SetProperty: setTEXTWINTYPE

$101 CONSTANT INPUTID
$102 CONSTANT OUTPUTID

: TEXTWINCHILD: 
  CREATE , 
  DOES> hTextWin @ R> @ GetDlgItem ;

OUTPUTID TEXTWINCHILD: TEXTWIN.OUTPUT
INPUTID  TEXTWINCHILD: TEXTWIN.INPUT

: TEXTWINPROC
  GETMSGWLPARAM hTextWin !
  
  uMsg @ WM_DESTROY = IF
    hTextWin @ REMOVEFROMLINK
  THEN  
  
  uMsg @ WM_SIZE = IF
    hTextWin @ RECT GetClientRect DROP
    TEXTWIN.OUTPUT 0 $1C RECT.RIGHT @ RECT.BOTTOM @ $1C - -1 MoveWindow DROP
    TEXTWIN.INPUT $4 $4 $50 $14 -1 MoveWindow DROP
  THEN
  TEXTWINCHILDPROC ?DUP IF EXECUTE THEN
  hTextWin @ uMsg @ wParam @ lParam @ DefWindowProcA
;

: TEXTWINONCREATE
  0 
  Z" EDIT"
  0
  $50200904     \ WS_CHILD+WS_VISIBLE+WS_VSCROLL+ES_NOHIDESEL+ES_MULTILINE+ES_READONLY
  CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  hTextWin @
  OUTPUTID
  HINST @
  0
  CreateWindowExA DROP
  
  0 
  Z" EDIT"
  0
  $50000104     \ WS_CHILD+WS_VISIBLE+ES_NOHIDESEL+ES_MULTILINE
  CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  hTextWin @
  INPUTID
  HINST @
  0
  CreateWindowExA DROP
  
  TEXTWIN.OUTPUT WM_SETFONT SYSTEM_FIXED_FONT GetStockObject 0 SendMessageA DROP
  TEXTWIN.INPUT WM_SETFONT SYSTEM_FIXED_FONT GetStockObject 0 SendMessageA DROP
;

' TEXTWINPROC MESSAGEHANDLER: &TEXTWINPROC

: newtextwin
  $0
  FORMCLASSNAMEA
  z" textwin"
  $10CF0180
  CW_USEDEFAULT CW_USEDEFAULT $200 $160
  0 0
  HINST @
  0
  CreateWindowExA hTextWin ! 
  
  hTextWin @ LASTTEXTWIN INSERTTOLINK  

  TEXTWINONCREATE

  hTextWin @ GWL_WNDPROC &TEXTWINPROC SetWindowLongA DROP
  hTextWin @ WM_SIZE 0 0 SendMessageA DROP
  hTextWin @ SetFocus DROP
;

: TEXTWIN.insertstring ( zbuf -- )  \ insert null terminate string into edit control
  >R
  TEXTWIN.OUTPUT WM_GETTEXTLENGTH 0 0 SendMessageA >R  
  TEXTWIN.OUTPUT EM_SETSEL     R> DUP SendMessageA DROP
  TEXTWIN.OUTPUT EM_REPLACESEL 0  R>  SendMessageA DROP
;

: TEXTWIN.clear
  TEXTWIN.OUTPUT EM_SETSEL 0 -1 SendMessageA DROP
  TEXTWIN.OUTPUT EM_REPLACESEL 0 z" " SendMessageA DROP
;