LoadLibrary ws2_32.dll CONSTANT winsock
$2 winsock WINAPI: WSAStartup
0  winsock WINAPI: WSACleanup
1  winsock WINAPI: inet_addr
1  winsock WINAPI: gethostbyname
$3 winsock WINAPI: socket
$3 winsock WINAPI: connect
$2 winsock WINAPI: shutdown
1  winsock WINAPI: closesocket
$4 winsock WINAPI: send
$4 winsock WINAPI: recv
$3 winsock WINAPI: bind
$2 winsock WINAPI: listen
$3 winsock WINAPI: accept

$2 CONSTANT AF_INET
1  CONSTANT SOCK_STREAM
-1 CONSTANT INADDR_NONE
-1 CONSTANT SOCKET_ERROR
0  CONSTANT INVALID_SOCKET
0  CONSTANT SD_RECEIVE
1  CONSTANT SD_SEND
$2 CONSTANT SD_BOTH

CREATE WSADATA $200 ALLOT
CREATE hostent $10 ALLOT
CREATE sockaddr_in 
       AF_INET C, 0 ,
       0 C, 0 C,
       0 ,
       0 , 0 ,
CREATE sinRemote $10 ALLOT
       
: sockaddr_in.port
  sockaddr_in 2 + 
;
: sockaddr_in.s_addr
  sockaddr_in CELL+
;

$101 WSADATA WSAStartup DROP
: ShutdownConnection ( sd -- )
  DUP SD_SEND shutdown SOCKET_ERROR = IF DROP EXIT THEN
  closesocket DROP
;

: opensocket ( addr port -- sd )
    \ Create a stream socket
    AF_INET SOCK_STREAM 0 socket DUP INVALID_SOCKET = IF EXIT THEN 
    >R
    DUP sockaddr_in.port 1+ C! $8 RSHIFT sockaddr_in.port C!        \ write a WORD
    sockaddr_in.s_addr !
    R>   \ sd
;

: LookupAddress ( zHost -- addr )
    DUP inet_addr DUP INADDR_NONE = IF
        DROP                                   \ drop INADDR_NONE
        gethostbyname ?DUP IF                  \ resolve it through DNS
          3 CELLS + @ @ @                      \ *((u_long*)pHE->h_addr_list[0]);
        ELSE INADDR_NONE THEN                  \ not resolve
        EXIT
    THEN
    SWAP DROP                                  \ drop zHost and return addr
;

CREATE httprequest
       CHAR G C,
       CHAR E C,
       CHAR T C,
       $20    C,
       CHAR / C,
       $0A0D0A0D ,
       0 ,
CREATE httprespone $1004 ALLOT       
VARIABLE sd
: testclient
  z" www.hinet.net" LookupAddress DUP INADDR_NONE = IF DROP ." error lookup address" EXIT THEN
  $50 opensocket sd !
  sd @ INVALID_SOCKET = IF ." error opening socket" EXIT THEN
  sd @ sockaddr_in $10 connect SOCKET_ERROR = IF ." error connect" EXIT THEN
  
  sd @ httprequest ZCOUNT 0 send SOCKET_ERROR = IF ." error sending request" EXIT THEN
  sd @ httprespone $1000  0 recv DUP SOCKET_ERROR = IF ." error receiving request" EXIT THEN
  httprespone SWAP DUMP
  sd @ ShutdownConnection 
;

VARIABLE remotesd
CREATE requestbuffer $100 ALLOT
VARIABLE readbyte
VARIABLE sinsize $10 sinsize !

: testserver
  0 $50 opensocket sd !
  sd @ INVALID_SOCKET = IF ." error opening socket" EXIT THEN  
  sd @ sockaddr_in $10 bind SOCKET_ERROR = IF ." error binding socket" EXIT THEN
  sd @ 1 listen DROP
  
  BEGIN
    PAUSE
    sd @ sinRemote sinsize accept remotesd ! 
    ." incoming client" remotesd ?
    remotesd @ INVALID_SOCKET = IF ." error accept" sd @ ShutdownConnection EXIT THEN
    
    BEGIN
    remotesd @ requestbuffer $100 0 recv readbyte !
    remotesd @ z" ok>" 4 0 send DROP
    requestbuffer C@ $1B = 
    UNTIL
    
    remotesd @ z" byebye" 7 0 send DROP
    remotesd @ closesocket DROP
    
  \ PAUSE ?KEY DUP IF DROP $1B = THEN
  UNTIL
  ." shutdown"
  sd @ ShutdownConnection
;